package com.hidglobal.omnikeydemo;

import timber.log.Timber;

import java.util.ArrayList;

public class ConvertionUtils {

  static String byteArrayToString(byte[] array, int shift) {
    String hex = "";
    for (int i = 0; i < array.length - shift; i++) {
      //hex += "0x" + Integer.toHexString(array[i] & 0x000000ff) + " ";
      hex += String.format("%02X", array[i]);
    }
    return hex;
  }

  static String byteArrayToAscii(byte[] array, int shift) {
    String hex = "";
    for (int i = 0; i < array.length - shift; i++) {
      hex += String.format("%02X", array[i]);
    }
    return hex;
  }

  public static byte[] hexStringToByteArray(String s) {
    byte[] b = new byte[s.length() / 2];
    for (int i = 0; i < b.length; i++) {
      int index = i * 2;
      int v = Integer.parseInt(s.substring(index, index + 2), 16);
      b[i] = (byte) v;
    }
    return b;
  }

  public static ArrayList<byte[]> extractParameters(byte[] data) throws IllegalArgumentException {

       ArrayList<byte[]> output = new ArrayList<byte[]>();

       try {
         if (data != null && data.length > 2) {

           int total = data[2] & 0x000000FF;
           byte tag = 0;
           int length = 0;
           int idx = 2;

           if (data[1] == (byte) 0x82) {
             total = ((data[2] & 0x000000FF) << 8) | (data[3] & 0x000000FF);
             idx = 4;
           } else if (data[1] == (byte) 0x81) {
             total = data[2] & 0x000000FF;
             idx = 3;
           } else
             total = data[1] & 0x000000FF;

           if (total == 0 || total > data.length) {
             return null;
           }

           while (idx < (total + 3)) {
             tag = data[idx];
             length = data[idx + 1] & 0x000000FF;

             if (tag == 0 || length > total) {
               return null;
             }

             byte[] value = new byte[length];
             System.arraycopy(data, idx + 2, value, 0, value.length);
             output.add(value);

             idx += 2 + length;
           }

           return output;
         }
       } catch (Exception e) {
         Timber.e(e);
       }
       return output;
     }
}
