package com.hidglobal.omnikeydemo

import android.content.Intent
import android.content.pm.PackageManager
import android.os.Bundle
import android.os.Handler
import android.support.v7.app.AppCompatActivity
import kotlinx.android.synthetic.main.splash_activity.*
import timber.log.Timber

class SplashActivity : AppCompatActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.splash_activity)

        try {
            appNameTxt.text = getString(R.string.title_activity_OMNIKEYDemo)
            versionTv.text = String.format(FORMAT_APP_VERSION, packageManager.getPackageInfo(packageName, 0).versionName)
        } catch (e: PackageManager.NameNotFoundException) {
            Timber.e("Package not found: %s", packageName)
        }

        Handler().postDelayed({
            startActivity(Intent(this, OmniKeyDemoActivity::class.java))
                    .also { finish() }
        }, SPLASH_TIME_OUT_MILLIS)
    }

    companion object {
        private const val SPLASH_TIME_OUT_MILLIS = 2_000L
        private const val FORMAT_APP_VERSION = "v%s"
    }
}
