package com.hidglobal.omnikeydemo.extensions

import android.smartcardio.Card
import android.smartcardio.CardException
import android.smartcardio.CommandAPDU
import com.hidglobal.omnikeydemo.ConvertionUtils
import timber.log.Timber

fun Card.sendAPDU(request: String): ByteArray? {
    return try {
        val cmd = CommandAPDU(ConvertionUtils.hexStringToByteArray(request))
        val resp = basicChannel.transmit(cmd)
        resp.bytes
    } catch (e: CardException) {
        Timber.e(e)
        null
    }
}