package com.hidglobal.omnikeydemo.usb

import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent


class UsbEventsReceiver(var listener: UsbEventsListener?) : BroadcastReceiver() {

    override fun onReceive(context: Context, intent: Intent) {
        when (intent.action) {
            READER_ATTACH_ACTION -> listener?.onUsbReaderAttached()
            READER_DETACH_ACTION -> listener?.onUsbReaderDetach()
        }
    }

    companion object {
        const val READER_ATTACH_ACTION = "com.hidglobal.ia.omnikey.intent.READER_ATTACHED"
        const val READER_DETACH_ACTION = "com.hidglobal.ia.omnikey.intent.READER_DETACHED"
    }
}

interface UsbEventsListener {
    fun onUsbReaderAttached()
    fun onUsbReaderDetach()
}